package lebrijo.services;

import java.util.List;

import javax.ejb.Local;
import javax.ejb.Remote;
import javax.ejb.Stateless;

import javax.persistence.EntityManager;

import javax.persistence.PersistenceContext;

import lebrijo.model.Departments;

import lebrijo.services.interfaces.DepartmentsService;
import lebrijo.services.interfaces.DepartmentsServiceLocal;

@Stateless(name = "DepartmentsService", mappedName = "DepartmentsService")
@Remote
@Local
public class DepartmentsServiceBean implements DepartmentsService,
                                               DepartmentsServiceLocal {
    @PersistenceContext(unitName="Model")
    private EntityManager em;

    public DepartmentsServiceBean() {
    }

    public Departments persistDepartments(Departments departments) {
        em.persist(departments);
        return departments;
    }

    public Departments mergeDepartments(Departments departments) {
        return em.merge(departments);
    }

    public void removeDepartments(Departments departments) {
        departments = em.find(Departments.class, departments.getDepartmentId());
        em.remove(departments);
    }

    /** <code>select o from Departments o</code> */
    public List<Departments> getDepartmentsFindAll() {
        return em.createNamedQuery("Departments.findAll").getResultList();
    }
}
