package lebrijo.services;

import java.util.List;

import javax.ejb.Local;
import javax.ejb.Remote;
import javax.ejb.Stateless;

import javax.persistence.EntityManager;

import javax.persistence.PersistenceContext;

import lebrijo.model.Employees;

import lebrijo.services.interfaces.EmployeesService;
import lebrijo.services.interfaces.EmployeesServiceLocal;

@Stateless(name = "EmployeesService", mappedName = "EmployeesService")
@Remote
@Local
public class EmployeesServiceBean implements EmployeesService,
                                             EmployeesServiceLocal {
    @PersistenceContext(unitName="Model")
    private EntityManager em;

    public EmployeesServiceBean() {
    }

    public Employees persistEmployees(Employees employees) {
        em.persist(employees);
        return employees;
    }

    public Employees mergeEmployees(Employees employees) {
        return em.merge(employees);
    }

    public void removeEmployees(Employees employees) {
        employees = em.find(Employees.class, employees.getEmployeeId());
        em.remove(employees);
    }

    /** <code>select o from Employees o</code> */
    public List<Employees> getEmployeesFindAll() {
        return em.createNamedQuery("Employees.findAll").getResultList();
    }

    /** <code>select o from Employees o where o.firstName like :p_name</code> */
    public List<Employees> getEmployeesFindByName(Object p_name) {
        return em.createNamedQuery("Employees.findByName").setParameter("p_name", p_name).getResultList();
    }
}
