package lebrijo.test;

import java.util.Hashtable;
import java.util.List;

import javax.naming.Context;
import javax.naming.InitialContext;

import javax.naming.NamingException;

import lebrijo.model.Employees;

import lebrijo.services.interfaces.EmployeesService;

public class EmployeesServiceClient {
    public static void main(String [] args) {
        try {
            final Context context = getInitialContext();
            EmployeesService employeesService = (EmployeesService)context.lookup("EmployeesService#lebrijo.services.interfaces.EmployeesService");
//            for (Employees employees : (List<Employees>)employeesService.getEmployeesFindAll()) {
//                printEmployees(employees);
//            }
            for (Employees employees : (List<Employees>)employeesService.getEmployeesFindByName( "P%" )) {
                printEmployees(employees);
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private static void printEmployees(Employees employees) {
        System.out.println( "commissionPct = " + employees.getCommissionPct() );
        System.out.println( "email = " + employees.getEmail() );
        System.out.println( "employeeId = " + employees.getEmployeeId() );
        System.out.println( "firstName = " + employees.getFirstName() );
        System.out.println( "hireDate = " + employees.getHireDate() );
        System.out.println( "jobId = " + employees.getJobId() );
        System.out.println( "lastName = " + employees.getLastName() );
        System.out.println( "phoneNumber = " + employees.getPhoneNumber() );
        System.out.println( "salary = " + employees.getSalary() );
        System.out.println( "manager = " + employees.getManager() );
        System.out.println( "employeesList = " + employees.getEmployeesList() );
        System.out.println( "departmentsList = " + employees.getDepartmentsList() );
        System.out.println( "departments = " + employees.getDepartments() );
    }

    private static Context getInitialContext() throws NamingException {
        Hashtable env = new Hashtable();
        // WebLogic Server 10.x connection details
        env.put( Context.INITIAL_CONTEXT_FACTORY, "weblogic.jndi.WLInitialContextFactory" );
        env.put(Context.PROVIDER_URL, "t3://127.0.0.1:7101");
        return new InitialContext( env );
    }
}
